<script>
import { init } from 'aos';
import WhyVideoModal from './video-modal.vue';
import PlayIcon from '~/static/nuxt-images/why/white-play-icon.vue';

export default {
  components: {
    WhyVideoModal,
    PlayIcon,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      modal: {
        open: false,
        video_link: '',
      },
    };
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  methods: {
    handleClick(buttonData) {
      if (buttonData.modal) {
        this.modal.open = true;
        // Make sure Vimeo analytics work:
        // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
        setTimeout(() => {
          // eslint-disable-next-line no-underscore-dangle
          window.__vimeoRefresh();
        }, 3000);
      }
    },
    closeModal() {
      this.modal.open = false;
    },
  },
};
</script>

<template>
  <section class="hero">
    <SlpContainer>
      <div
        :data-aos="data.aos_animation"
        :data-aos-duration="data.aos_duration"
      >
        <SlpRow>
          <SlpColumn :cols="6">
            <div class="mobile-pieces">
              <img
                src="/nuxt-images/why/orange-piece.svg"
                alt="Mobile Orange Piece"
                aria-hidden="true"
              />
              <img
                src="/nuxt-images/why/yellow-piece.svg"
                alt="Mobile Yellow Piece"
                aria-hidden="true"
              />
            </div>

            <SlpTypography tag="h1" variant="heading2">
              {{ data.header }}
            </SlpTypography>
            <SlpTypography tag="h2">
              {{ data.subheader }}
            </SlpTypography>
            <div class="buttons">
              <SlpButton
                class="slp-mr-8"
                variant="secondary"
                :href="data.primary_button.link"
                :data-ga-name="data.primary_button.data_ga_name"
                :data-ga-location="data.primary_button.data_ga_location"
                >{{ data.primary_button.text }}</SlpButton
              >
              <SlpButton
                variant="tertiary"
                :data-ga-name="data.secondary_button.data_ga_name"
                :data-ga-location="data.secondary_button.data_ga_location"
                @click.native="handleClick(data.secondary_button)"
                >{{ data.secondary_button.text }}<PlayIcon />
              </SlpButton>
            </div>
          </SlpColumn>
          <SlpColumn
            :cols="6"
            class="piece-images"
            data-aos="fade-down"
            data-aos-offset="500"
            data-aos-duration="1500"
          >
            <img
              src="/nuxt-images/why/orange-piece.svg"
              alt="Orange Piece"
              aria-hidden="true"
            />
            <img
              src="/nuxt-images/why/yellow-piece.svg"
              alt="Yellow Piece"
              aria-hidden="true"
            />
          </SlpColumn>
        </SlpRow>
      </div>
    </SlpContainer>
    <WhyVideoModal v-if="modal.open" light-background @close="closeModal">
      <template #body>
        <iframe
          ref="video"
          src="https://player.vimeo.com/video/702922416?h=06212a6d7c"
          title="Video player"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </template>
    </WhyVideoModal>
  </section>
</template>

<style lang="scss" scoped>
.hero {
  background: $color-primary-200;
  color: white;
  padding-bottom: $spacing-64;

  .mobile-pieces {
    display: none;
  }

  h1 {
    color: $color-accent-100;
    font-weight: $font-weight-bold;
    margin-top: 120px;
    margin-bottom: $spacing-16;
    z-index: 1;
  }

  h2 {
    color: $color-text-50;
    font-weight: $font-weight-bold;
    font-size: $text-display-1;
    line-height: 120px;
    margin-bottom: 40px;
    z-index: 1;

    @media (max-width: 576px) {
      font-size: $text-display-1-mobile;
    }
  }

  .slp-btn-tertiary {
    color: $color-surface-50;

    svg {
      margin-left: $spacing-8;
      fill: $color-surface-50;
    }

    &:hover {
      color: $color-text-300;

      svg {
        fill: $color-surface-700;
      }
    }
  }

  .piece-images {
    position: relative;
    padding-top: $spacing-64;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    img:first-of-type {
      margin: 0 0 0 auto;
    }

    img {
      display: block;
      width: 100%;
      max-width: 300px;
      max-height: 200px;
    }
  }
}

@media (max-width: 376px) {
  .hero .buttons {
    .slp-btn {
      width: 100%;
      justify-content: center;

      &:first-of-type {
        margin-bottom: $spacing-8;
      }
    }
  }
}

@media (max-width: 767px) {
  .hero {
    .piece-images {
      display: none;
    }

    .mobile-pieces {
      display: block;

      img {
        max-width: 100px;
        max-height: 100px;
        z-index: -1;
      }

      img:first-of-type {
        position: absolute;
        top: 05%;
        right: 15%;
      }

      img:last-of-type {
        position: absolute;
        bottom: 0px;
        right: 15%;
      }
    }
  }
}
</style>
